'*******************************************************************************
'             STEROWNIK SYNTEZY CZESTOTLIWOSCI Z UKLADEM SAA1057
'*******************************************************************************
'Autor :  Micha Wojtkw
'Data  :  12.10.2003
'e-mail:  michallo4@wp.pl
'www   :  www.michallo.ll.pl
'GG#   :  714371
'uwagi :  program ustepniony dla www.easy-soft.prv.pl
'*******************************************************************************
'                       KONFIGURACJA PODSTAWOWA
'*******************************************************************************
$crystal = 4190000                                     'deklaracja rezonatora
$regfile = "4433def.dat"                               'wybr procesora
Config Lcd = 20 * 4
Config Lcdpin = Pin , Db4 = Portb.1 , Db5 = Portb.2 , Db6 = Portb.3 , Db7 = Portb.4 , Rs = Portd.7 , E = Portb.0
Cursor Off                                             'wyczenie kursora
Config Debounce = 30                                   'ustawienie zwoki dla drga stykw klawiatury
Config Pinc.3 = Output                                 ' SPI
Config Pinc.4 = Output                                 ' SPI
Config Pinc.5 = Output                                 ' SPI
Config Pinc.2 = Output                                 ' wyjscie podswietlania
Config Pinc.1 = Output                                 ' wyjscie monostabilne
Config Pinc.0 = Output                                 ' wyjscie bistabilne
Config Pind.4 = Input                                  ' key 1
Config Pind.3 = Input                                  ' key 2
Config Pind.2 = Input                                  ' key 3
Config Pind.1 = Input                                  ' key 4
Config Pind.0 = Input                                  ' key 5
Dim Czestot1 As Word                                   'zmienna danych dla SAA1057
Dim Czestot2 As Word                                   'zmienna pomicnicza
Dim A As Byte                                          '
Dim Key As Byte                                        '
Dim _eep(4) As Byte                                    ' dane odczytane z eeprom
Dim Frequency As Word                                  ' zmienna dla czestotliwosci
Dim Setup As Word                                      ' zmienna dla ustawien
Dim Mnoznik As Byte                                    ' zmienna dla mnoznika 100 i 125
Dim Pokazanaf As Long                                  ' zmienna obliczen czestotliwosci
Dim Pokazanaff As String * 10                          '
Dim Pokazanafstr As String * 10                        '
Portc.0 = 1                                            '
Portc.1 = 1                                            '
Podswietlanie Alias Portc.2                            'alias dla wyjscia podswietlania
Reset Podswietlanie                                    'wczenie powietlania
Dat Alias Portc.5                                      'aliasy dla SPI
Enalbe_ Alias Portc.4                                  '
Clok Alias Portc.3                                     '
'*******************************************************************************
'                             poczatek programu
'*******************************************************************************
Gosub Odczyt_ustawien                                  ' sprawdz ostanie nastawy
Cls
Locate 1 , 1
Lcd "michallo PLL-Driver"                              'powitanie
Locate 2 , 7
Lcd "Welcome"
Wait 2
Cls
Locate 1 , 4
Lcd "Nie do konca"
Locate 2 , 3
Lcd "komercyjne radio"
Wait 2
'*******************************************************************************
'                               Petla glowna
'*******************************************************************************
Petla_glowna:
Cls
Locate 1 , 5
Pokazanaf = Frequency * Mnoznik
Pokazanaff = Str(pokazanaf)
Pokazanafstr = Format(pokazanaff , "00.0000")
Pokazanaff = Format(pokazanafstr , "000.0")
Lcd Pokazanaff : Lcd " MHz"
Podswitlanie_off:
For A = 1 To 250
Gosub Klawisz
If Key = 1 Then : Gosub Menu : End If
If Key = 2 Then : Toggle Portc.0 : End If
If Pind.2 = 0 Then : Portc.1 = 0 : Else : Portc.1 = 1 : End If
If Key = 4 Then : Goto Frequency : End If
Waitms 20
Next A
Set Podswietlanie
Do
Gosub Klawisz
If Key = 1 Then : Gosub Menu : End If
If Key = 2 Then : Toggle Portc.0 : End If
If Pind.2 = 0 Then : Portc.1 = 0 : Else : Portc.1 = 1 : End If
If Key = 4 Then : Goto Frequency : End If
If Key = 5 Then : Reset Podswietlanie : Goto Podswitlanie_off : End If
Loop
'*******************************************************************************
'                         Obsluga syntezy SAA1057
'podprogram do komunikacji z SAA1057, dane (16 bitow) do wyslania
'musza byc podstawione pod zmienna czestot1 ktora jest zdeklarowana jako
'zmienna word, zmienna czestot2 jest zmienna pomocnicza,
'ktorej nie uzywamy bezposrednio czyli nic pod nie podstawiamy,
'Ot cala filozofia sterowania ukadem SAA1057
'dane jakie maja zostac wysane mozna sobie odczytac w pdf lub w moich
'podprogramach.
'*******************************************************************************
Saa:                                                   'wyslanie wartoci f/u do syntezy
Dat = 0
Enalbe_ = 0
Clok = 0
Waitms 5
Enalbe_ = 1
Waitms 5
Clok = 1
Waitms 5
Clok = 0
Waitms 5
For A = 0 To 15                                        'szesnacie danych do wysania
Rotate Czestot1 , Left , 1
Czestot2 = Czestot1 And 1
If Czestot2 = 0 Then
Dat = 0
Else
Dat = 1
End If
Waitms 5
Clok = 1
Waitms 5
Clok = 0
Waitms 5
Next A
Enalbe_ = 0
Waitms 5
Clok = 1
Waitms 5
Clok = 0
Waitms 5
Enalbe_ = 1
Dat = 1
Clok = 1
Waitms 100
Return
'*******************************************************************************
'                        OBSLUGA KLAWIATURY
'*******************************************************************************
Klawisz:
Key = 0
Debounce Pind.4 , 0 , Przypisanie , Sub
Debounce Pind.3 , 0 , Przypisanie , Sub
Debounce Pind.2 , 0 , Przypisanie , Sub
Debounce Pind.1 , 0 , Przypisanie , Sub
Debounce Pind.0 , 0 , Przypisanie , Sub
Return

Przypisanie:
If Pind.4 = 0 Then : Key = 1 : End If
If Pind.3 = 0 Then : Key = 2 : End If
If Pind.2 = 0 Then : Key = 3 : End If
If Pind.1 = 0 Then : Key = 4 : End If
If Pind.0 = 0 Then : Key = 5 : End If
Return
'*******************************************************************************
'                                 menu
'*******************************************************************************
Menu:
Reset Podswietlanie
Cls
Locate 1 , 1
Lcd "1-SetupPLL    2-freq"
Locate 2 , 7
Lcd "3-format"
Waitms 500
Do
Gosub Klawisz
If Key = 1 Then : Goto Setup : End If
If Key = 2 Then : Goto Frequency : End If
If Key = 3 Then : Goto Formatt : End If
If Key = 5 Then : Goto Petla_glowna : End If
Loop
'*******************************************************************************
'                                setup
'*******************************************************************************
Setup:
Cls
Locate 1 , 1
Lcd "1-krok 2-PradPLL"
Locate 2 , 1
Lcd "3-Test 4-Det. 5-out"
Waitms 500
Do
Gosub Klawisz
If Key = 1 Then : Goto Krok : End If
If Key = 2 Then : Goto Prad : End If
If Key = 3 Then : Goto Test : End If
If Key = 4 Then : Goto Detector : End If
If Key = 5 Then : Goto Menu : End If
Loop
'*******************************************************************************
'                                 KROK
'*******************************************************************************
Krok:
Cls
Locate 1 , 1
Lcd "Krok PLL:"
Locate 2 , 1
Lcd "1-10kHz   2-12,5kHz"
Waitms 500
Do
Gosub Klawisz
If Key = 1 Then : Goto 10khz : End If
If Key = 2 Then : Goto 12khz : End If
If Key = 5 Then : Goto Setup : End If
Loop
'*******************************************************************************
'                                 PRAD
'*******************************************************************************
Prad:
Cls
Locate 1 , 1
Lcd "1-0,023 2-0,07 [mA]"
Locate 2 , 1
Lcd "3-0,23 4-0,7 5-2,3"
Waitms 500
Do
Gosub Klawisz
If Key = 1 Then : Goto Current1 : End If
If Key = 2 Then : Goto Current2 : End If
If Key = 3 Then : Goto Current3 : End If
If Key = 4 Then : Goto Current4 : End If
If Key = 5 Then : Goto Current5 : End If
Loop
'*******************************************************************************
'                                  TEST
'*******************************************************************************
Test:
Cls
Locate 1 , 1
Lcd "1-log.1 2-F.ref"
Locate 2 , 1
Lcd "3-count. 4-synchr."
Waitms 500
Do
Gosub Klawisz
If Key = 1 Then : Goto Log1 : End If
If Key = 2 Then : Goto F_ref : End If
If Key = 3 Then : Goto Count : End If
If Key = 4 Then : Goto Synch : End If
If Key = 5 Then : Goto Setup : End If
Loop
'*******************************************************************************
'                                  detector
'*******************************************************************************
Detector:
Cls
Locate 1 , 5
Lcd "1-AUTO  2-ON"
Locate 2 , 8
Lcd "3-OFF"
Waitms 500
Do
Gosub Klawisz
If Key = 1 Then : Goto Auto : End If
If Key = 2 Then : Goto _on : End If
If Key = 3 Then : Goto _off : End If
If Key = 5 Then : Goto Setup : End If
Loop
'*******************************************************************************
'                                  10khz
'*******************************************************************************
10khz:
Setup.13 = 0
Gosub Ustaw
Mnoznik = 100
Frequency = 9200
Gosub Ustaw1
Goto Krok
'*******************************************************************************
'                                  12Khz
'*******************************************************************************
12khz:
Setup.13 = 1
Gosub Ustaw
Mnoznik = 125
Frequency = 7680
Gosub Ustaw1
Goto Krok
'*******************************************************************************
'                                 Current1:
'*******************************************************************************
Current1:
Setup.9 = 0
Setup.10 = 0
Setup.11 = 0
Setup.12 = 0
Gosub Ustaw
Goto Setup
'*******************************************************************************
'                                 Current2:
'*******************************************************************************
Current2:
Setup.9 = 1
Setup.10 = 0
Setup.11 = 0
Setup.12 = 0
Gosub Ustaw
Goto Setup
'*******************************************************************************
'                                 Current3:
'*******************************************************************************
Current3:
Setup.9 = 0
Setup.10 = 1
Setup.11 = 0
Setup.12 = 0
Gosub Ustaw
Goto Setup
'*******************************************************************************
'                                 Current4:
'*******************************************************************************
Current4:
Setup.9 = 0
Setup.10 = 1
Setup.11 = 1
Setup.12 = 0
Gosub Ustaw
Goto Setup
'*******************************************************************************
'                                 Current5:
'*******************************************************************************
Current5:
Setup.9 = 0
Setup.10 = 1
Setup.11 = 1
Setup.12 = 1
Gosub Ustaw
Goto Setup
'*******************************************************************************
'                                  Log1
'*******************************************************************************
Log1:
Setup.0 = 0
Setup.1 = 0
Setup.2 = 0
Setup.3 = 0
Gosub Ustaw
Goto Test
'*******************************************************************************
'                                  F_ref
'*******************************************************************************
F_ref:
Setup.0 = 0
Setup.1 = 0
Setup.2 = 1
Setup.3 = 0
Gosub Ustaw
Goto Test
'*******************************************************************************
'                                  count
'*******************************************************************************
Count:
Setup.0 = 1
Setup.1 = 0
Setup.2 = 0
Setup.3 = 0
Gosub Ustaw
Goto Test
'*******************************************************************************
'                                  synch
'*******************************************************************************
Synch:
Setup.0 = 1
Setup.1 = 0
Setup.2 = 1
Setup.3 = 0
Gosub Ustaw
Goto Test
'*******************************************************************************
'                                  auto
'*******************************************************************************
Auto:
Setup.5 = 0
Setup.6 = 0
Gosub Ustaw
Goto Detector
'*******************************************************************************
'                                   on
'*******************************************************************************
_on:
Setup.5 = 0
Setup.6 = 1
Gosub Ustaw
Goto Detector
'*******************************************************************************
'                                  off
'*******************************************************************************
_off:
Setup.5 = 1
Setup.6 = 1
Gosub Ustaw
Goto Detector
'*******************************************************************************
'                                frequency
'                    podprogram zmiany czestotliwosci
'*******************************************************************************
Frequency:
Reset Podswietlanie
Cls
Locate 1 , 5
Pokazanaf = Frequency * Mnoznik
Pokazanaff = Str(pokazanaf)                            'Frequency * Mnoznik
Pokazanafstr = Format(pokazanaff , "00.0000")
Pokazanaff = Format(pokazanafstr , "000.0")
Lcd Pokazanaff : Lcd " MHz"
Locate 2 , 1
Lcd "1-UP  (FREQ)  DOWN-2"
Waitms 500
Do
Gosub Klawisz
If Key = 1 Then : Gosub Up : End If
If Key = 2 Then : Gosub Down : End If
If Key = 3 Then : Gosub Ustaw1 : End If
If Key = 4 Then : Goto Petla_glowna : End If
If Key = 5 Then : Gosub Ustaw1 : Goto Menu : End If
Loop
'*******************************************************************************
'                                  UP
'      zmiana o jeden krok czestotliwosci w gr
'*******************************************************************************
Up:
Frequency = Frequency + 1
Pokazanaf = Frequency * Mnoznik
Pokazanaff = Str(pokazanaf)                            'Frequency * Mnoznik
Pokazanafstr = Format(pokazanaff , "00.0000")
Pokazanaff = Format(pokazanafstr , "000.0")
Locate 1 , 1
Lcd "                    "
Locate 1 , 5
Lcd Pokazanaff : Lcd " MHz"
Return

'*******************************************************************************
'                                  down
'     zmiania o jeden krok czestotliwosci w d
'*******************************************************************************
Down:
Frequency = Frequency - 1
Pokazanaf = Frequency * Mnoznik
Pokazanaff = Str(pokazanaf)                            'Frequency * Mnoznik
Pokazanafstr = Format(pokazanaff , "00.0000")
Pokazanaff = Format(pokazanafstr , "000.0")
Locate 1 , 1
Lcd "                    "
Locate 1 , 5
Lcd Pokazanaff : Lcd " MHz"
Return
'*******************************************************************************
'                                  format
' pomocnicza funkcja, pomagajaca opanowac sterownik po zaprogramowaniu lub
'  checi powrotu do ustawien poczatkowych
'*******************************************************************************
Formatt:
Setup = 49605                                          '&B1100000111000101
Gosub Ustaw
Frequency = 9200
Gosub Ustaw1
Gosub Odczyt_ustawien
Goto Menu
'*******************************************************************************
'                           odczyt ustawien
'odczytanie z pamieci EEPROM nastaw parametrow i czestotliwosci,
'                       oraz ustawinie ich w SAA1057
'*******************************************************************************
Odczyt_ustawien:
For A = 1 To 4
Readeeprom _eep(a) , A
Waitms 50
Next A
Setup = Makeint(_eep(3) , _eep(4))
Czestot1 = Setup
Gosub Saa
Frequency = Makeint(_eep(1) , _eep(2))
Czestot1 = Frequency
Gosub Saa
If Setup.13 = 0 Then : Mnoznik = 100 : Else : Mnoznik = 125 : End If
Return
'*******************************************************************************
'                                 Ustaw
' ustawienie w SAA1057 parametrow petli PLL oraz zapis do pamieci EEPROM
'*******************************************************************************
Ustaw:
Czestot1 = Setup
Gosub Saa
_eep(3) = Low(setup)
_eep(4) = High(setup)
Writeeeprom _eep(3) , 3
Writeeeprom _eep(4) , 4
Return

'*******************************************************************************
'                                 Ustaw1
' ustawienie w SAA1057 czstotliwosci i zapis w pamieci EEPROM
'*******************************************************************************
Ustaw1:
Czestot1 = Frequency
Gosub Saa
_eep(1) = Low(frequency)
_eep(2) = High(frequency)
Writeeeprom _eep(1) , 1
Writeeeprom _eep(2) , 2
Return

'*******************************************************************************
'                                 The End ?
'*******************************************************************************
